Bug 1475966 - [webadmin automation] the IDs of all toolbar buttons are not static anymore
[webadmin automation] the IDs of all toolbar buttons are not static anymore
Product: ovirt-engine
Classification: oVirt
Component: Frontend.WebAdmin (Show other bugs)
Unspecified Unspecified
unspecified Severity high (vote)
: ovirt-4.2.0
: ---
Assigned To: Greg Sheremeta
Pavel Novotny
: AutomationBlocker
Depends On:
  Show dependency treegraph
Reported: 2017-07-27 12:06 EDT by Pavel Novotny
Modified: 2017-12-20 06:24 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: No Doc Update
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2017-12-20 06:24:01 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: UX
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rule-engine: ovirt‑4.2+
rule-engine: planning_ack+
rule-engine: devel_ack+
pnovotny: testing_ack+

Attachments (Terms of Use)
screenshot: toolbar buttons - static / semi-dynamic IDs (340.11 KB, image/png)
2017-07-27 12:06 EDT, Pavel Novotny
no flags Details
fixed (41.32 KB, image/png)
2017-08-01 17:08 EDT, Greg Sheremeta
no flags Details

External Trackers
Tracker ID Priority Status Summary Last Updated
oVirt gerrit 80077 master MERGED webadmin: added static IDs to action buttons 2017-08-02 08:17 EDT

  None (edit)
Description Pavel Novotny 2017-07-27 12:06:21 EDT
Created attachment 1305530 [details]
screenshot: toolbar buttons - static / semi-dynamic IDs

Description of problem:
The IDs of all toolbar buttons in all main and detail views are not static anymore.
The IDs now have a dynamic prefix, e.g., 'gwt-uid-337_New', but it should be 'MainTabDataCenterView_table_New'. See the screenshot attached.

This has a great negative impact on our web UI automation.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. In Webadmin, go to Compute / Data Centers.
2. Inspect the New button widget with built-in developer tools, i.e.,
   right-click on the button and select Inspect / Inspect Element (for Chrome / Firefox).
3. Check the 'id' attribute of the <button/> tag.

Actual results:
<button type="button" class="btn btn-default" id="gwt-uid-337_New">New</button>

Expected results:
<button type="button" class="btn btn-default" id="MainTabDataCenterView_table_New">New</button>

Additional info:

Data tables, dialogs and other widgets with static IDs are not affected.

Regression against ovirt-engine-webadmin-portal-4.2.0-0.0.master.20170712143425.gitcb02bb5.el7.centos.noarch
Comment 1 Red Hat Bugzilla Rules Engine 2017-07-27 12:06:27 EDT
This bug report has Keywords: Regression or TestBlocker.
Since no regressions or test blockers are allowed between releases, it is also being identified as a blocker for this release. Please resolve ASAP.
Comment 2 Oved Ourfali 2017-07-28 03:41:47 EDT
Marking it as a regression doesn't make sense. It isn't a broken feature.
Comment 3 Pavel Novotny 2017-07-28 10:24:19 EDT
Why this should not be a regression?
A functionality for generating static IDs worked before but now is broken. Therefore it's a regression.
Regressions are not applicable only to RFEs.
Comment 4 Oved Ourfali 2017-07-28 15:49:09 EDT
Regression comes to say a functionality of the product is now broken. 
The ids are an implementation detail. 
I understand it is important for automation, and Greg is assigned and will examine it, but it isn't a regression in terms of project functionality.
Comment 5 Greg Sheremeta 2017-08-01 17:08 EDT
Created attachment 1307807 [details]
Comment 6 Pavel Novotny 2017-09-04 10:30:23 EDT
Verified in ovirt-engine-webadmin-portal-4.2.0-0.0.master.20170903205106.gitb17261a.el7.centos.noarch

IDs of the action buttons are now static again, although they are no longer unique.
Buttons with the same label have the same ID, which can slightly complicate things, for example, when there are two buttons "Edit" present on the page at the same time.
Comment 7 Sandro Bonazzola 2017-12-20 06:24:01 EST
This bugzilla is included in oVirt 4.2.0 release, published on Dec 20th 2017.

Since the problem described in this bug report should be
resolved in oVirt 4.2.0 release, published on Dec 20th 2017, it has been closed with a resolution of CURRENT RELEASE.

If the solution does not work for you, please open a new bug report.

Note You need to log in before you can comment on or make changes to this bug.